<?php
use LabBase\Model\Brand;
use LabBase\Model\BrandPost;
use LabBase\Model\Category;
use LabBase\Model\User;

$brandBannerChangeURL = $this->url('root/brandSettings', ['action' => 'uploadBanner', 'param' => $this->thisBrand->url]);

$thisBrandLogoURL = \LabBase\Model\ImageSaver::GetImageS3LinkFromName('brand-avatar-'.$this->thisBrand->id);
$thisBrandURL = $this->url('root/brandFeed', ['brandUrl' => $this->thisBrand->url]);

/** @var $user User */
$user = $this->sessionInfo()->getLoggedInUser();
?>

<script>
    var g_thisBrand = {
        id: <?= $this->thisBrand->id; ?>,
        name: '<?= addslashes($this->thisBrand->name); ?>',
        category: '<?= addslashes($this->categoryUrl); ?>',
        url: '<?= addslashes($this->thisBrand->url); ?>',
        loveCount: <?= $this->thisBrand->loveCount; ?>,
        lovedByUser: <?= $this->brandLovedByUser ? 'true' : 'false' ?>
    };
    <?php if($user) { ?>

    var g_loggedInUser = {
        id: <?= $user->id; ?>,
        name: '<?= addslashes($user->fullName) ?>',
        isAdmin: <?= $user->isAdmin() ? 'true' : 'false'  ?>,
        canEditBrand: <?= $this->userCanEditBrand ? 'true' : 'false' ?>
    };
    <?php }else{ ?>
    var g_loggedInUser = false;
    <?php } ?>
</script>

<?php


$brandName = null;
if($this->BrandName) {
    $brandName = $this->BrandName;
    $brandUrl = $this->BrandUrl;
    $brandDescription = $this->BrandDescription;
}else{
    if ($user && $user->lastVisitedBrandId !== null) {
        /** @var Brand $brand */
        $brand = $this->sessionInfo()->getBrandById($user->lastVisitedBrandId);
        if ($brand) {
            $brandName = $brand->name;
            $brandDescription = $brand->description;
            $brandUrl = $brand->url;
        }
    }
    else{
        $brandName = $this->thisBrand->name;
        $brandDescription = $this->thisBrand->description;
        $brandUrl = $this->thisBrand->url;
    }
}
$thisBrand = $this->thisBrand;
?>


<iframe id="editorImageSubmitterIframe" name="editorImageSubmitterIframe" style="display: none;" onload="if(this.contentWindow.location.href != 'about:blank' && window.imageUploadSubmitted) {window.imageUploadSubmitted(this)}"> </iframe>
<form onsubmit="window.imageUploadStarted()" enctype="multipart/form-data" method="post" target="editorImageSubmitterIframe" action="<?= $this->url('root/aboutMeAddImage', ['brandUrl' => $brandUrl]); ?>">
    <input type="file" name="image" style="display: none" id="editorImageSubmitter" onchange="$(this).parent().submit()" />
</form>
<script>
    window.imageUploadStarted = function() {
        window.postImageUploadFinished = window.loadingIndicator($('body')); 
    };
    window.imageUploadEnded = function() {
        if (window.postImageUploadFinished) {
            window.postImageUploadFinished();
        }
    };

    window.imageSubmittedCallback = false;
    window.imageUploadSubmitted = function(el) {
        window.imageUploadEnded();

        if(window.imageSubmittedCallback === false) return;
        var iframeContents = $(el)[0].contentDocument.body.innerHTML;

        var re = /\{[\-a-zA-Z"'0-9:\w|.,/\\]+\}/.exec(iframeContents);
        if(re == null) {
            labAlert("An error has occured while uploading the photo.");
            window.imageSubmittedCallback(false);
            window.imageSubmittedCallback = false;
            return;
        }
        var response = re[0];
        response = JSON.parse(response);
        console.log("Successfully uploaded image:", response);
        window.imageSubmittedCallback(response.imageLink);
        window.imageSubmittedCallback = false;
    };
</script>


<!-- Header -->
    <?php echo $this->render('user-header.phtml', array('user' => $user, 'thisBrand' => $this->thisBrand, 'draftspostCnt' => $this->draftspostCnt, 'brandName' => $brandName, 'thisBrandLogoURL' => $thisBrandLogoURL, 'userCanEditBrand' => $this->userCanEditBrand)); ?>
<!--END-->

<div class="body-content">
   
    <div class="wrapper">

        <!-- Sidebar Layout -->
        <div class="sidebar-layout">
            <?php echo $this->render('user-menu.phtml', array('page' => 'portfolio', 'brandUrl' => $this->thisBrand->url)); ?>
            
            <!-- Main Content -->
            <div class="main-content">
            
                <div class="panel panel-default about_me_section">
                    
                    <div class="panel-body">
                       
                       Portfolio Section of personel page
                                               
                    </div>
                    
                </div>
               
            </div>
            
            <!-- Sidebar -->
            <?php echo $this->render('user-sidebar.phtml', array('user' => $user, 'thisBrand' => $this->thisBrand, 'brandName' => $brandName, 'thisBrandLogoURL' => $thisBrandLogoURL)); ?>
        <!--END-->
        
        </div>
    </div>
    
</div>

<!-- Footer -->
    <?php echo $this->render('brand-footer.phtml', array('user' => $user, 'thisBrand' => $this->thisBrand, 'draftspostCnt' => $this->draftspostCnt, 'brandName' => $brandName, 'thisBrandLogoURL' => $thisBrandLogoURL)); ?>
<!--END-->

<input type="hidden" value="<?php echo $this->postType; ?>" name="hdnPostType" id="hdnPostType" />

<script>

    function calculateDates() {
        var postType = document.getElementById('hdnPostType').value;
        var elements = document.querySelectorAll("[data-date]");
        for(var el in elements) {
            if(!elements.hasOwnProperty(el)) continue;
            el = elements[el];
            if(postType == 'drafts')
            {
                el.innerHTML = 'saved '+formatAgoTime(el.dataset.date);
            }
            else
            {
                el.innerHTML = formatAgoTime(el.dataset.date);
            }
        }
    }
    window.setInterval(calculateDates, 1000 * 29);
    window.onGloabalJS.push(calculateDates);

    <? if($user) { ?>
    window.onGloabalJS.push(function() {
        window.getNotifications('feed-template');
    });
    <? } ?>

    function updateLoveUsButton() {
        if(g_thisBrand.lovedByUser) {
            $('#loveUsButton .text').text('Loved!');
        }else{
            $('#loveUsButton .text').text('Love Us');
        }
    }

    window.loveUsClicked = function(el) {
        var loveBool = !g_thisBrand.lovedByUser;
        window.ajaxSubmitCheck("<?= $this->url("root/interactionController", ["action" => "loveBrand", "param" => $this->thisBrand->id, "param2" => "BOOL"]) ?>".replace(/BOOL/, loveBool), {}, function (data) {
            g_thisBrand.lovedByUser = data.newValue;
            updateLoveUsButton();
        }, "Could not love the brand. %s");
    };
    onGloabalJS.push(updateLoveUsButton);

    function changeBrandAvatar() {
        <?php if($this->userCanEditBrand) { ?>
        labImage('Change brand avatar image', function(imageData) {
            if(imageData) {
                $('.loading-container').show();
                window.ajaxSubmitCheck('<?= $this->url('root/brandSettings', ['action'=>'uploadAvatar', 'param' => $this->thisBrand->url]) ?>', {
                    imageString: imageData.data.split('base64,', 2)[1]
                }, function() {
                    document.location.reload();
                }, "The brand avatar couldn't be changed. %s");
            }
        }, 400, 400);
        <?php }else{ ?>
        return false;
        <?php } ?>
    }    
    
    var UploadedImagesListSelAboutme = '.upload-image-list-aboutme';
    
    window.onGloabalJS.push(function() {
        window.uploadImageSetStorageAboutme = window.persistentVariableAboutme("uploadImageSetAboutme", new window.ImageSet([], UploadedImagesListSelAboutme));
        if(window.uploadImageSetStorageAboutme.get().type !== 'ImageSet') {
            window.uploadImageSetStorageAboutme.set(new window.ImageSet([], UploadedImagesListSelAboutme));
        }
        console.log("uploadImageSetAboutme = ", window.uploadImageSetStorageAboutme, window.uploadImageSetStorageAboutme.get());
    });
    
    function uploadImageToEditorAboutme(img) {
        console.log(img);
        console.log('Upload Aboutme image Aboutme');
        var imageSetAboutme = uploadImageSetStorageAboutme.get();
        imageSetAboutme.addImages([img]);
        window.uploadImageSetStorageAboutme.set(imageSetAboutme);
    }
    
    function uploadImage(type) {
        var handelClass = '.upload-image-list-'+type;
        window.imageSubmittedCallback = uploadImageToEditorAboutme;
        
        $("#editorImageSubmitter").click();
    }
    
    function removeImageClicked(el, type) {
        var $container = $(el).closest('.img-container');
        var $img = $('img', $container);
        var confirm = labConfirm("Are you sure you want to delete this image?", "Confirm delete",
        function(response) {
            if(response) {
                removeImage($img.attr('src'), type);
            }
        }, "Delete", "Cancel");
    }

    function removeImage(img, type) {
        switch(type)
        {
            case 'aboutme' : 
                    var imageSet = window.uploadImageSetStorageAboutme.get();
                    imageSet.removeImages([img]);
                    window.uploadImageSetStorageAboutme.set(imageSet);
                    
                    $('.upload-image-list-aboutme').hide();
                    $('.upload_aboutme_photo').show();
                    
                break;            
        }
    }
    
    function editUserProfile(aboutMeId)
    {
        var name = $('#hdnAboutMeName').val();
        var desc = $('#hdnAboutMeDescription').val();
        var img = $('#hdnAboutMeImage').val();
        
        $('.aboutme_data_section').fadeOut('slow', function(){
            $('.aboutme-photo-show').fadeOut('slow');
            $('.aboutme_form_section .aboutme_name').val(name);
            $('.aboutme_form_section .aboutme_description').val(desc);
            $('.aboutme_form_section #hdnAboutMeId').val(aboutMeId);
            if(img != "")
            {
                uploadImageToEditorAboutme(img);
            }
            $('.aboutme_form_section').fadeIn('slow');
        });
        
        
    }
    
    console.log("REG ONLOAD");
    window.onload = function() {
        console.log("FIRE ONLOAD");
       
       $(document).on('mouseover', '.small-image-section .img-container', function(e) {
            e.preventDefault();
            var $this = $(this);
            var $panel = $('.img-panel', $this);
            if($panel.closest('.small-image-section').hasClass('editable')) {
                var type = $panel.closest('.small-image-section').data('type');
                $panel.toggleClass('active');
                if($panel.hasClass('active')) {
                    $('.img-panel', $this.parent().parent()).removeClass('active');
                    $panel.addClass('active');
                }
                if ($panel.hasClass('new')) {
                    $panel.removeClass('new');
                    $panel.html('<div class="buttons"><button type="button" onclick="removeImageClicked(this, \''+type+'\');" class="icon-close"></button></div>');
                }
            }
        });
        
       $(document).on('click', '.small-image-section .img-container', function(e) {
            e.preventDefault();
            var $this = $(this);
            var $panel = $('.img-panel', $this);
            if($panel.closest('.small-image-section').hasClass('editable')) {
                var type = $panel.closest('.small-image-section').data('type');
                $panel.toggleClass('active');
                if($panel.hasClass('active')) {
                    $('.img-panel', $this.parent().parent()).removeClass('active');
                    $panel.addClass('active');
                }
                if ($panel.hasClass('new')) {
                    $panel.removeClass('new');
                    $panel.html('<div class="buttons"><button type="button" onclick="removeImageClicked(this, \''+type+'\');" class="icon-close"></button></div>');
                }
            }
        });
       
       if($('.upload-image-list-aboutme div.img-row').length > 0)
        {
            $('.upload-image-list-aboutme').show();
            $('.upload_aboutme_photo').hide();
        }
       
        var $textareas = $('textarea.autoresize');

        // Comments
        window.autosizeTextarea($('.comment-form textarea.comment-content'), 60, 300);
        window.autosizeTextarea($textareas, 80, 1000); // todo: fix
    }
   
</script>


